import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Obsticles here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public abstract class Obsticles  extends Actor
{

    private static final double WALKING_SPEED = 4.0;
    private static final double MOVING_SPEED = 2.0;
    
    /**
     * Turn 90 degrees to the right (clockwise).
     */
    public void turn()
    {
        turn(180);
    }
    
    public void move(double distance)
    {
        double angle = Math.toRadians( getRotation() );
        int x = (int) Math.round(getX() + Math.cos(angle) * distance);
        int y = (int) Math.round(getY() + Math.sin(angle) * distance);
        
        setLocation(x, y);
    }
    
    public boolean atWorldEdge()
    {
        if(getX() < 20 || getX() > getWorld().getWidth() - 20)
            return true;
        if(getY() < 20 || getY() > getWorld().getHeight() - 20)
            return true;
        else
            return false;
    }
    
    public void turn(int angle)
    {
        setRotation(getRotation() + angle);
    }
    
    public void move()
    {
        move(WALKING_SPEED);
    }

    public void moveDown()
    {
        move(WALKING_SPEED);
    }
    public void method1()
    {
        setRotation(getRotation()+5);
    }
     public void method2()
    {
        move();
            if(atWorldEdge()){
                turn();
            }
            if(bounce()){
                turn();
            }
    }
    public void method3()
    {   
        move(MOVING_SPEED);
            if(atWorldEdge()){
                turn();
            }
            if(bounce()){
                turn();
            }
    }
    public boolean bounce()
    {
        Actor bounce=getOneIntersectingObject(Obsticle1.class);
        return bounce!= null;
    }
    public void rotate()
    {
        setRotation(getRotation()+180);
    }
}
